// This file is licensed under the terms of the CC-LGPL. 
//
// NOTA: Las llantas del vehiculo son obra de F.Dispot
// donadas a la biblioteca POVRay (administrada por Misha Riser) 
// para su libre uso (inclusive comercial por defecto) el 26 junio 2001
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 28 octubre 2015
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas
// definido como 0.001 para POVRAY
//                      
// CVTF CarroVehicularTetraFord
// El archivo dibuja un carro poco flexible. El archivo,
// permite redefinir las texturas, abrir las ventanas, abrir las puertas y girar las ruedas.
// Un alto porcentaje del modelo fue disenado mediante la herramienta Epspline.exe,
// para prismas. 
// El interesado puede conseguir el programa Epspline.exe en 
// htp://agalena.nfshost.com/b1/ 
//      
// La siguiente macro dibuja el objeto default: 
// #macro CVTF_Carro()    
//                                             
// La siguiente macro permite mover algunos elementos:                               
// #macro CVTF_CarroVehicularTetraFord(   
//            GiroPuertaDelanteraDerecha , GiroPuertaDelanteraIzquierda  ,  
//            GiroPuertaPosteriorDerecha , GiroPuertaPosteriorIzquierda  ,     
//            GiroRuedasDelanteras       , AnguloRodar                   ,
//            FraccionAbrirVentanaDerecha, FraccionAbrirVentanaIzquierda )  
//      GiroPuertaDelanteraDerecha          : Angulo positivo para abrir la puerta
//          delantera derecha del conductor.
//      GiroPuertaDelanteraIzquierda        : Angulo positivo para abrir la puerta
//          delantera izquierda del conductor.
//      GiroPuertaPosteriorDerecha          : Angulo positivo para abrir la puerta
//          posterior a la derecha del conductor.
//      GiroPuertaPosteriorIzquierda        : Angulo positivo para abrir la puerta
//          posterior a la izquierda del conductor.   
//      GiroRuedasDelanteras                : Angulo de giro paralelo al eje Y,
//          de las ruedas delanteras. Para movimiento curvo.
//      AnguloRodar                         : Angulo para rotar las cuatro ruedas
//          sobre si mismas.
//      FraccionAbrirVentanaDerecha         : Fraccion propia para abrir la Ventana
//          a la derecha del conductor.
//      FraccionAbrirVentanaIzquierda       : Fraccion propia para abrir la ventana
//          a la izquierda del conductor.
//  
//                                                        
// Las dimensiones del objeto default son :  
//      Minimo                  : <-1620,    0,- 670>*L
//      Maximo                  : <+1625,  885,+ 670>*L  
// El frente del carro en direccion X-. Se encuentra parcialmente
// centrado sobre el plano XZ, gravedad Y-.
// 
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse.
// CVTF_DefaultTexturaPrincipal
//      Textura principal del carro
// CVTF_DefaultTexturaProtector    
//      Textura de los parachoques
// CVTF_DefaultTexturaBrazo       
//      Textura de los brazos interiores a la puerta
// CVTF_DefaultTexturaRespaldar                     
//      Textura del respaldar de los asientos
// CVTF_DefaultTexturaManivela               
//      Textura de las manivelas
// CVTF_DefaultTexturaBajos     
//      Textura de las zonas bajas
// CVTF_DefaultTexturaBombillo    
//      Textura del vidrio de las luces
// CVTF_DefeaultTexturaFondoBombillo
//      Textura de fondo de las luces delanteras   
// CVTF_DefaultTexturaFondoBombilloPosterior
//      Textura de fondo de las luces posteriores
// CVTF_DefaultMaterialVidrio
//      Material de las ventanas del carro
//   
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare CVTF_TexturaPrincipal               = CVTF_DefaultTexturaPrincipal
//      Textura principal del carro
// #declare CVTF_TexturaProtector               = CVTF_DefaultTexturaProtector    
//      Textura de los parachoques
// #declare CVTF_TexturaBrazo                   = CVTF_DefaultTexturaBrazo       
//      Textura de los brazos interiores a la puerta
// #declare CVTF_TexturaRespaldar               = CVTF_DefaultTexturaRespaldar                     
//      Textura del respaldar de los asientos
// #declare CVTF_TexturaManivela                = CVTF_DefaultTexturaManivela               
//      Textura de las manivelas
// #declare CVTF_TexturaBajos                   = CVTF_DefaultTexturaBajos     
//      Textura de las zonas bajas
// #declare CVTF_TexturaBombillo                = CVTF_DefaultTexturaBombillo    
//      Textura del vidrio de las luces
// #declare CVTF_TexturaFondoBombillo           = CVTF_DefaultTexturaFondoBombillo
//      Textura de fondo de las luces delanteras   
// #declare CVTF_TexturaFondoBombilloPosterior  = CVTF_DefaultTexturaFondoBombilloPosterior
//      Textura de fondo de las luces posteriores
// #declare CVTF_MaterialVidrio                 = CVTF_DefaultMaterialVidrio
//      Material de las ventanas del carro
// #declare CVTF_ImagenPlaca                            = "CVTF_IM2.jpg"
//      Imagen para la placa del carro.           
// #declare CVTF_ManivelaDerechaIzquierda               = false;
//      "true" ubica la manivela a la derecha del conductor. Si "false" a la izquierda.
//
// Para colocarlo simplemente
//
// #include "CVTF.inc"
//  object                  {
//    CVTF_Carro( ) 
//  }
//
//  o bien la misma figura con la macro detallada... 
//  #include "CVTF.inc"
//  object                  { 
//    CVTF_CarroVehicularTetraFord(0,0,0,0,0,0,0,0)  
//  }
//
//  o bien se puede redefinir alguna textura 
//  #include "CVTF.inc"                            
//  #include "textures.inc"
//  #declare CVTF_TexturaPrincipal = PinkAlabaster 
//  object                  {                                   
//    CVTF_Carro()
//  }
// 

#declare CVTF_ArmazonFrontal_USE_NORMAL_TRANSFORM       = on;
#declare CVTF_ArmazonSuperior_USE_NORMAL_TRANSFORM      = on;
#declare CVTF_ArmazonLateral_USE_NORMAL_TRANSFORM       = on; 
#declare CVTF_L                 = 0.001;      
#include "CVTF_EX1.inc"
#include "CVTF_AU1.inc"  
#include "CVTF_AU2.inc"
#include "CVTF_AU3.inc"   
#include "CVTF_AU4.inc"   
#include "CVTF_AU5.inc"   
#include "metals.inc"  
#include "stones.inc"  
#declare CVTF_ImagenPlaca                   = "CVTF_IM2.jpg"; 
#declare CVTF_ManivelaDerechaIzquierda      = false;

#declare CVTF_DefaultTexturaPrincipal       =
  texture                                   {    
    pigment                                 {   
      color ( 1*Red+2*Scarlet+1*Firebrick )/4
    }   
    normal                                  {    
       pavement                                 
       number_of_sides  4
       number_of_tiles  6           
      turbulence        0.01
      scale             0.4       
      slope_map
      { [0 <0.5, 0>]
        [.5 <.75, 1>]
        [1 <1, 0>]
      }
      rotate           90*x
    }     
    normal                                  {    
       pavement                                 
       number_of_sides  4
       number_of_tiles  6           
       turbulence        0.01
       scale             0.4       
       slope_map
         { [0 <0.5, 0>]
           [.5 <.75, 1>]
           [1 <1, 0>]
         }
    }     
    finish                                  {  
      metallic
      phong albedo 0.9 phong_size 60
    }
  }
  
#ifndef ( CVTF_TexturaPrincipal )
  #declare CVTF_TexturaPrincipal            = CVTF_DefaultTexturaPrincipal
#end  // #ifndef ( CVTF_TexturaPrincipal ) 

#declare CVTF_DefaultTexturaProtector       = 
  texture                                   { 
    T_Chrome_1C
    normal                                  {    
      checker       
      normal {
        gradient y    
        triangle_wave
        scale         0.005
        slope_map           
        { [0 <0, 0>]
          [.1 <1, 1>]
          [.1 <1, 0>]
          [.9 <1, 0>]
          [.9 <1, -1>]         
          [1 <0, 0>]
        }                           
      }       
      normal { bumps }                        
      translate            -0.5*x+0.5*z+0.94*y    
      scale                 <1,1,0.3>
  //    scale                 
    }
  }  
  texture                               {  
    pigment                             {
      checker 
      pigment                           {
        gradient y      
        triangle_wave
        scale         0.005    
        pigment_map                     {  
          [ 0.0 color Black  transmit 0.5 ]
          [ 0.2 color Black  transmit 0.5 ]
          [ 0.2 color Silver transmit 0.5 ]
          [ 1.0 color Silver transmit 0.5 ]
        } 
      }
      pigment  { Clear }
      translate            -0.5*x+0.5*z+0.94*y    
      scale                 <1,1,0.3>
    }
  }
  
#ifndef ( CVTF_TexturaProtector )        
  #declare CVTF_TexturaProtector            = CVTF_DefaultTexturaProtector
#end  // #ifndef ( CVTF_TexturaProtector )    

#declare CVTF_DefaultMaterialVidrio         =
  material                                  {
        texture { pigment{ rgbf <0.98, 0.98, 0.98, 0.9> }
                  finish { diffuse 0.1 reflection 0.2  
                          specular 0.8 roughness 0.0003 phong 1 phong_size 400}
                } // end of texture -------------------------------------------
        interior{ ior 1.5 caustics 0.5
                } // end of interior ------------------------------------------
  }
  
#ifndef ( CVTF_MaterialVidrio )        
  #declare CVTF_MaterialVidrio              = CVTF_DefaultMaterialVidrio      
#end  // #ifndef ( CVTF_MaterialVidrio )         
   
#declare CVTF_DefaultTexturaBrazo           =
  texture                                   {      
    T_Grnt15
    normal                                  {     
      quilted 
      control0      0.5
      control1          0.5  
      scale         0.1
    }                   
    scale           0.1
  }   
                                     
#ifndef ( CVTF_TexturaBrazo )
  #declare CVTF_TexturaBrazo                = CVTF_DefaultTexturaBrazo
#end  // #ifndef ( CVTF_TexturaBrazo )
       
#declare CVTF_DefaultTexturaRespaldar       =
  texture                                   {     
    T_Grnt6
    normal                                  {   
      gradient z 
      turbulence        0.1
      scale         0.1
    }                   
    normal                                  { 
      gradient  y
      sine_wave     
      turbulence    0.025
      scale         0.025
        slope_map           
        { [0 <0, 0>]
          [.1 <1, 1>]
          [.1 <1, 0>]
          [.9 <1, 0>]
          [.9 <1, -1>]         
          [1 <0, 0>]
        }                           
    }
  }                    
  
#ifndef ( CVTF_TexturaRespaldar )        
  #declare CVTF_TexturaRespaldar            = CVTF_DefaultTexturaRespaldar
#end  // #ifndef ( CVTF_TexturaRespaldar )                                
                 
#declare CVTF_DefaultTexturaManivela        =
  texture                                   {  
    T_Stone31
    normal                                  {   
      bumps
      scale             0.1
    }
  }     
                                                                      
#declare CVTF_DefaultTexturaBajos           =
  texture                                   {    
    T_Chrome_3B  
    normal                                  {     
       pavement                                 
       number_of_sides  4
       number_of_tiles  6     
       pattern          31      
       turbulence        0.1 
       scale            0.025   
    } 
  }
                                                                        
#ifndef ( CVTF_TexturaBajos )        
  #declare CVTF_TexturaBajos                = CVTF_DefaultTexturaBajos
#end  // #ifndef ( CVTF_TexturaBajos )  
  
#ifndef ( CVTF_TexturaManivela ) 
  #declare CVTF_TexturaManivela             = CVTF_DefaultTexturaManivela
#end  // #ifndef ( CVTF_TexturaManivela )   

#declare CVTF_DefaultTexturaFondoBombillo          =
  texture                                   {   
    pigment                                 {
      White
    } 
  }                                         
  
  
#ifndef ( CVTF_TexturaFondoBombillo )        
  #declare CVTF_TexturaFondoBombillo        = CVTF_DefaultTexturaFondoBombillo
#end  // #ifndef ( CVTF_TexturaFondoBombillo )  

#declare CVTF_DefaultTexturaFondoBombilloPosterior          =
  texture                                   {   
    pigment                                 {
     White
    }                
  }                                         
  
  
#ifndef ( CVTF_TexturaFondoBombilloPosterior )        
  #declare CVTF_TexturaFondoBombilloPosterior           = 
                    CVTF_DefaultTexturaFondoBombilloPosterior
#end  // #ifndef ( CVTF_TexturaFondoBombilloPosterior )  


#declare CVTF_DefaultTexturaBombillo            =
  texture                                   {  
    pigment                                 {   
      quilted      
      turbulence        0.2
      scale         0.01
      pigment_map                           { 
        [ 0.0 color White transmit 1.0 ]
        [ 1.0 color White transmit 0.1 ]
      }
    }           
    normal                                  {  
      cubic
      scale         0.01
    }
  } 
  
#ifndef ( CVTF_TexturaBombillo )
  #declare CVTF_TexturaBombillo             = CVTF_DefaultTexturaBombillo
#end  // #ifndef ( CVTF_TexturaBombillo )  
                    
#macro CVTF_CarroVehicularTetraFord(   
            GiroPuertaDelanteraDerecha  , GiroPuertaDelanteraIzquierda  ,  
            GiroPuertaPosteriorDerecha  , GiroPuertaPosteriorIzquierda  ,     
            GiroRuedasDelanteras        , AnguloRodar                   ,
            FraccionAbrirVentanaDerecha , FraccionAbrirVentanaIzquierda )  
  union                         {              
    #local L                            = CVTF_L;
    #local LargoFundamental             = 3218*L;
    #local TexturaPrincipal             = CVTF_TexturaPrincipal;
    #local TexturaProtector             = CVTF_TexturaProtector;
    #local TexturaBrazo                 = CVTF_TexturaBrazo;
    #local TexturaRespaldar             = CVTF_TexturaRespaldar;
    #local TexturaManivela              = CVTF_TexturaManivela;
    #local TexturaBajos                 = CVTF_TexturaBajos;
    #local TexturaBombillo              = CVTF_TexturaBombillo;
    #local TexturaFondoBombillo         = CVTF_TexturaFondoBombillo;   
    #local TexturaFondoBombilloPosterior        = CVTF_TexturaFondoBombilloPosterior;
    #local MaterialVidrio               = CVTF_MaterialVidrio;
    #local FactorAnchoLargo     = 1/2.66;                                
    #local PosRuedaDelanteraDerecha     = +0.70*FactorAnchoLargo*z/2-0.3375*x-0.085*y;  
    #local PosRuedaPosteriorDerecha     = +0.75*FactorAnchoLargo*z/2+0.2625*x-0.085*y;  
    #local EjePuertaDelanteraDerecha    = +0.90*FactorAnchoLargo*z/2-0.150*x;  
    #local EjePuertaPosteriorDerecha    = +0.90*FactorAnchoLargo*z/2+0.0525*x;   
    #local PosLuzDelanteraDerecha       =  -0.495*x-0.050*y-0.110*z;
    #local PosLuzPosteriorDerecha       =  +0.495*x-0.045*y-0.120*z;
    #local CarroceriaBase       =   
        intersection                { 
          object                    {
            CVTF_ArmazonLateral 
            rotate                  -90*x  
          } 
          union                     {                       
            object                    {  
              CVTF_ArmazonSuperior  
              translate             -( FactorAnchoLargo-CVTF_ArmazonSuperior_height/CVTF_ArmazonSuperior_width)*z/2
            }                          
            object                    {  
              CVTF_ArmazonSuperior         
              translate             -( FactorAnchoLargo-CVTF_ArmazonSuperior_height/CVTF_ArmazonSuperior_width)*z/2
              scale                 <1,1,-1>  
            }                          
          }   
          union                     {
            object                    {   
              CVTF_ArmazonFrontal      
              scale                   CVTF_ArmazonFrontal_max_extent/CVTF_ArmazonLateral_max_extent*<1,0,1>+y
              rotate                  90*y
              rotate                  90*z  
              translate               -( FactorAnchoLargo-1.1*CVTF_ArmazonFrontal_width/CVTF_ArmazonLateral_max_extent )*z/2
            }                          
            object                    {   
              CVTF_ArmazonFrontal      
              scale                   CVTF_ArmazonFrontal_max_extent/CVTF_ArmazonLateral_max_extent*<1,0,1>+y
              rotate                  90*y
              rotate                  90*z
              translate               -( FactorAnchoLargo-1.1*CVTF_ArmazonFrontal_width/CVTF_ArmazonLateral_max_extent )*z/2      
              scale                   <1,1,-1>
            }                          
          }
        }                
    #local CarroceriaInterna    =
        object                  {  
          CarroceriaBase
          scale                 0.975
        }                       
    #local BloqueVentanaFrontal =
        union                   {
            object                    {   
              CVTF_VentanaFrontal   
              transform             { CVTF_ArmazonFrontal_NORMAL_TRANSFORM }   
              scale                   CVTF_ArmazonFrontal_max_extent/CVTF_ArmazonLateral_max_extent*<1,0,1>+y
              rotate                  90*y
              rotate                  90*z  
              translate               -( FactorAnchoLargo-1.1*CVTF_ArmazonFrontal_width/CVTF_ArmazonLateral_max_extent )*z/2
            }                          
            object                    {   
              CVTF_VentanaFrontal     
              transform             { CVTF_ArmazonFrontal_NORMAL_TRANSFORM } 
              scale                   CVTF_ArmazonFrontal_max_extent/CVTF_ArmazonLateral_max_extent*<1,0,1>+y
              rotate                  90*y
              rotate                  90*z
              translate               -( FactorAnchoLargo-1.1*CVTF_ArmazonFrontal_width/CVTF_ArmazonLateral_max_extent )*z/2      
              scale                   <1,1,-1>
            }                          
        }    
    #local VentanaFrontal       =
        intersection            {   
          difference            {  
            object              {  
              CarroceriaBase
              scale             0.995
            }                        
            object              {  
              CarroceriaInterna 
              scale             0.970
            }
          }                     
          object                {  
            BloqueVentanaFrontal
          }
        } 
    #local Protectores          =    
        intersection                {   
          union                     {
            object                    {
              CVTF_ProtectorLateral 
              transform             { CVTF_ArmazonLateral_NORMAL_TRANSFORM }   
              rotate                  -90*x  
            }                          
            object                    {
              CVTF_ProtectorLateral2 
              transform             { CVTF_ArmazonLateral_NORMAL_TRANSFORM }   
              rotate                  -90*x  
            }                          
          }
          union                     {                       
            object                    {  
              CVTF_ProtectorSuperior  
              transform             { CVTF_ArmazonSuperior_NORMAL_TRANSFORM }   
              translate             -( FactorAnchoLargo-CVTF_ArmazonSuperior_height/CVTF_ArmazonSuperior_width)*z/2
            }                          
            object                    {  
              CVTF_ProtectorSuperior         
              transform             { CVTF_ArmazonSuperior_NORMAL_TRANSFORM }   
              translate             -( FactorAnchoLargo-CVTF_ArmazonSuperior_height/CVTF_ArmazonSuperior_width)*z/2
              scale                 <1,1,-1>  
            }                          
            object                    {  
              CVTF_ProtectorSuperior2  
              transform             { CVTF_ArmazonSuperior_NORMAL_TRANSFORM }   
              translate             -( FactorAnchoLargo-CVTF_ArmazonSuperior_height/CVTF_ArmazonSuperior_width)*z/2
            }                          
            object                    {  
              CVTF_ProtectorSuperior2         
              transform             { CVTF_ArmazonSuperior_NORMAL_TRANSFORM }   
              translate             -( FactorAnchoLargo-CVTF_ArmazonSuperior_height/CVTF_ArmazonSuperior_width)*z/2
              scale                 <1,1,-1>  
            }                          
          }   
          union                     {
            object                    {   
              CVTF_ProtectorFrontal      
              transform             { CVTF_ArmazonFrontal_NORMAL_TRANSFORM }   
              scale                   CVTF_ArmazonFrontal_max_extent/CVTF_ArmazonLateral_max_extent*<1,0,1>+y
              rotate                  90*y
              rotate                  90*z  
              translate               -( FactorAnchoLargo-1.1*CVTF_ArmazonFrontal_width/CVTF_ArmazonLateral_max_extent )*z/2
            }                          
            object                    {   
              CVTF_ProtectorFrontal      
              transform             { CVTF_ArmazonFrontal_NORMAL_TRANSFORM }   
              scale                   CVTF_ArmazonFrontal_max_extent/CVTF_ArmazonLateral_max_extent*<1,0,1>+y
              rotate                  90*y
              rotate                  90*z
              translate               -( FactorAnchoLargo-1.1*CVTF_ArmazonFrontal_width/CVTF_ArmazonLateral_max_extent )*z/2      
              scale                   <1,1,-1>
            }                          
          }
        }    
    #local BaseCajuelaDelantera     = 
      union                         {
        object                      {    
          CVTF_Cajuela
          transform             { CVTF_ArmazonSuperior_NORMAL_TRANSFORM }   
          translate             -( FactorAnchoLargo-CVTF_ArmazonSuperior_height/CVTF_ArmazonSuperior_width)*z/2
        }
        object                      {  
          CVTF_Cajuela
          transform             { CVTF_ArmazonSuperior_NORMAL_TRANSFORM }   
          translate             -( FactorAnchoLargo-CVTF_ArmazonSuperior_height/CVTF_ArmazonSuperior_width)*z/2
          scale                 <1,1,-1>  
        }                              
      }
    #local CajuelaDelantera         =  
      union                         {
          intersection                  {  
            union                         {     
              object                      {  
                BaseCajuelaDelantera
                scale                   <1,0.95,1.1>
                translate               +0.01*x 
              }
            }                              
            object                      {  
              CarroceriaBase    
            }
            texture                 {  
              TexturaPrincipal
            }                 
            texture                 {   
              pigment { Black transmit 0.9 }
            }                
          }                          
          intersection                  {  
            union                         {     
              object                      {  
                BaseCajuelaDelantera
                scale                 <1,1,0.99>
                translate               -0.005*x 
              }
            }                              
            object                      {  
              CarroceriaBase    
            } 
            texture                     { 
              TexturaPrincipal
            }
          }                          
      }   
    #local BaseCajuelaPosterior     = 
      union                         {
        object                      {    
          CVTF_Cajuela2
          transform             { CVTF_ArmazonSuperior_NORMAL_TRANSFORM }   
          translate             -( FactorAnchoLargo-CVTF_ArmazonSuperior_height/CVTF_ArmazonSuperior_width)*z/2
        }
        object                      {  
          CVTF_Cajuela2
          transform             { CVTF_ArmazonSuperior_NORMAL_TRANSFORM }   
          translate             -( FactorAnchoLargo-CVTF_ArmazonSuperior_height/CVTF_ArmazonSuperior_width)*z/2
          scale                 <1,1,-1>  
        }                              
      }
    #local CajuelaPosterior         =  
      union                         {
          intersection                  {  
            union                         {     
              object                      {  
                BaseCajuelaPosterior
                scale                   <1,0.95,1.1>
                translate               -0.01*x 
              }
            }                              
            object                      {  
              CarroceriaBase    
            }
            texture                 {  
              TexturaPrincipal
            }                 
            texture                 {   
              pigment { Black transmit 0.9 }
            }                
          }                          
          intersection                  {  
            union                         {     
              object                      {  
                BaseCajuelaPosterior
                scale                 <1,1,0.99>
                translate               +0.005*x 
              }
            }                              
            object                      {  
              CarroceriaBase    
            } 
            texture                     { 
              TexturaPrincipal
            }
          }                          
      }   
    #local Motor                    =
      intersection                  {
          object                    {
            CVTF_MotorLateral 
            transform             { CVTF_ArmazonLateral_NORMAL_TRANSFORM }   
            rotate                  -90*x  
          } 
          union                     {                       
            object                    {  
              CVTF_MotorSuperior  
              transform             { CVTF_ArmazonSuperior_NORMAL_TRANSFORM }   
              translate             -( FactorAnchoLargo-CVTF_ArmazonSuperior_height/CVTF_ArmazonSuperior_width)*z/2
            }                          
            object                    {  
              CVTF_MotorSuperior         
              transform             { CVTF_ArmazonSuperior_NORMAL_TRANSFORM }   
              translate             -( FactorAnchoLargo-CVTF_ArmazonSuperior_height/CVTF_ArmazonSuperior_width)*z/2
              scale                 <1,1,-1>  
            }                          
          }   
          union                     {
            object                    {   
              CVTF_MotorFrontal      
              transform             { CVTF_ArmazonFrontal_NORMAL_TRANSFORM }   
              scale                   CVTF_ArmazonFrontal_max_extent/CVTF_ArmazonLateral_max_extent*<1,0,1>+y
              rotate                  90*y
              rotate                  90*z  
              translate               -( FactorAnchoLargo-1.1*CVTF_ArmazonFrontal_width/CVTF_ArmazonLateral_max_extent )*z/2
            }                          
            object                    {   
              CVTF_MotorFrontal      
              transform             { CVTF_ArmazonFrontal_NORMAL_TRANSFORM }   
              scale                   CVTF_ArmazonFrontal_max_extent/CVTF_ArmazonLateral_max_extent*<1,0,1>+y
              rotate                  90*y
              rotate                  90*z
              translate               -( FactorAnchoLargo-1.1*CVTF_ArmazonFrontal_width/CVTF_ArmazonLateral_max_extent )*z/2      
              scale                   <1,1,-1>
            }                          
          }
      } 
    #local BasePuertaDelantera          =
      object                            {  
        CVTF_PuertaLateral
        transform             { CVTF_ArmazonLateral_NORMAL_TRANSFORM }
        rotate                  -90*x  
        scale                   <1,0.95,1>   
      } 
    #local BasePuertaDelanteraDerecha   =
      object                            {
        difference                      {  
          intersection                  {     
            object                      { 
              BasePuertaDelantera
            }                
            plane                       {  
              -z, 0
            }    
            object                      {    
              CarroceriaBase
            }
          } 
          object                        {   
            CarroceriaBase
            scale               <1,1,0.975>
          }
        }
      }                                 
    #local BaseVidrioDelantero          =
          object                          {   
            CVTF_VidrioLateral
            transform             { CVTF_ArmazonLateral_NORMAL_TRANSFORM }
            rotate                  -90*x  
            scale                   <1,0.95,1>   
          }    
    #local BaseVidrioPosterior          =
          object                          {   
            CVTF_VidrioLateral2
            transform             { CVTF_ArmazonLateral_NORMAL_TRANSFORM }
            rotate                  -90*x  
            scale                   <1,0.95,1>   
          }    
    #local BaseVidrioPosterior2         =
          object                          {   
            CVTF_VidrioLateral3
            transform             { CVTF_ArmazonLateral_NORMAL_TRANSFORM }
            rotate                  -90*x  
            scale                   <1,0.95,1>   
          }    
    #local PuertaDelanteraDerecha       =  
      union                                 {
        difference                          {    
          union                             {
            object                          {
              BasePuertaDelanteraDerecha
              translate                     -EjePuertaDelanteraDerecha+0.1*x   
              scale                         <0.975,0.975,1>
              translate                     +EjePuertaDelanteraDerecha-0.095*x            
            }
            object                          {
              BasePuertaDelanteraDerecha
              translate                     -EjePuertaDelanteraDerecha+0.1*x   
              translate                     -0.005*z
              translate                     +EjePuertaDelanteraDerecha-0.1*x    
              texture                       {  
                TexturaPrincipal
              }                 
              texture                       {   
                pigment                     {   
                  color Black transmit 0.9
                }
              }
            }
    
          }
          object                          { 
            BaseVidrioDelantero  
          }    
        }
      }   
    #local BasePuertaPosterior          =
      object                            {  
        CVTF_PuertaLateral2
        transform             { CVTF_ArmazonLateral_NORMAL_TRANSFORM }
        rotate                  -90*x  
        scale                   <1,0.95,1>   
      }                  
    #local BasePuertaPosteriorDerecha   =
      object                            {
        difference                      {  
          intersection                  {     
            object                      { 
              BasePuertaPosterior
            }                
            plane                       {  
              -z, 0
            }    
            object                      {    
              CarroceriaBase
            }
          } 
          object                        {   
            CarroceriaBase
            scale               <1,1,0.975>
          }
        }
      }                 
    #local PuertaPosteriorDerecha       = 
      union                             {
        difference                      {
          union                             {  
            object                          {
              BasePuertaPosteriorDerecha
              translate                     -EjePuertaPosteriorDerecha+0.1*x   
              scale                         <0.975,0.975,1>
              translate                     +EjePuertaPosteriorDerecha-0.095*x            
            }
            object                          {
              BasePuertaPosteriorDerecha
              translate                     -EjePuertaPosteriorDerecha+0.1*x   
              translate                     -0.005*z
              translate                     +EjePuertaPosteriorDerecha-0.1*x    
              texture                       {  
                TexturaPrincipal
              }                 
              texture                       {   
                pigment                     {   
                  color Black transmit 0.9
                }
              }
            }
          }
          object                          { 
            BaseVidrioPosterior  
          }    
          object                          { 
            BaseVidrioPosterior2  
          }    
        }
      } 
    #local BrazoDelantero               =
      intersection                          {
          object                    {
            CVTF_BrazoLateral 
            transform             { CVTF_ArmazonLateral_NORMAL_TRANSFORM }   
            rotate                  -90*x  
          } 
          union                     {                       
            object                    {  
              CVTF_BrazoSuperior  
              transform             { CVTF_ArmazonSuperior_NORMAL_TRANSFORM }   
              translate             -( FactorAnchoLargo-CVTF_ArmazonSuperior_height/CVTF_ArmazonSuperior_width)*z/2
            }                          
          }   
          union                     {
            object                    {   
              CVTF_BrazoFrontal      
              transform             { CVTF_ArmazonFrontal_NORMAL_TRANSFORM }   
              scale                   CVTF_ArmazonFrontal_max_extent/CVTF_ArmazonLateral_max_extent*<1,0,1>+y
              rotate                  90*y
              rotate                  90*z  
              translate               -( FactorAnchoLargo-1.1*CVTF_ArmazonFrontal_width/CVTF_ArmazonLateral_max_extent )*z/2
            }                          
          } 
          plane                     {    
            -y, 0.10
          }
      }       
    #local BrazoPosterior           =
      intersection                          {
          object                    {
            CVTF_BrazoLateral2 
            transform             { CVTF_ArmazonLateral_NORMAL_TRANSFORM }   
            rotate                  -90*x  
          } 
          union                     {                       
            object                    {  
              CVTF_BrazoSuperior2  
              transform             { CVTF_ArmazonSuperior_NORMAL_TRANSFORM }   
              translate             -( FactorAnchoLargo-CVTF_ArmazonSuperior_height/CVTF_ArmazonSuperior_width)*z/2
            }                          
          }   
          union                     {
            object                    {   
              CVTF_BrazoFrontal      
              transform             { CVTF_ArmazonFrontal_NORMAL_TRANSFORM }   
              scale                   CVTF_ArmazonFrontal_max_extent/CVTF_ArmazonLateral_max_extent*<1,0,1>+y
              rotate                  90*y
              rotate                  90*z  
              translate               -( FactorAnchoLargo-1.1*CVTF_ArmazonFrontal_width/CVTF_ArmazonLateral_max_extent )*z/2
            }                          
          }
      }  
    #local RespaldarPosterior       =       
      intersection                  {
          object                    {
            CVTF_RespaldarPosteriorLateral 
            transform             { CVTF_ArmazonLateral_NORMAL_TRANSFORM }   
            rotate                  -90*x  
          } 
          union                     {                       
            object                    {  
              CVTF_RespaldarPosteriorSuperior  
              transform             { CVTF_ArmazonSuperior_NORMAL_TRANSFORM }   
              translate             -( FactorAnchoLargo-CVTF_ArmazonSuperior_height/CVTF_ArmazonSuperior_width)*z/2
            }                          
            object                    {  
              CVTF_RespaldarPosteriorSuperior         
              transform             { CVTF_ArmazonSuperior_NORMAL_TRANSFORM }   
              translate             -( FactorAnchoLargo-CVTF_ArmazonSuperior_height/CVTF_ArmazonSuperior_width)*z/2
              scale                 <1,1,-1>  
            }                          
          }   
          union                     {
            object                    {   
              CVTF_RespaldarPosteriorFrontal      
              transform             { CVTF_ArmazonFrontal_NORMAL_TRANSFORM }   
              scale                   CVTF_ArmazonFrontal_max_extent/CVTF_ArmazonLateral_max_extent*<1,0,1>+y
              rotate                  90*y
              rotate                  90*z  
              translate               -( FactorAnchoLargo-1.1*CVTF_ArmazonFrontal_width/CVTF_ArmazonLateral_max_extent )*z/2
            }                          
            object                    {   
              CVTF_RespaldarPosteriorFrontal      
              transform             { CVTF_ArmazonFrontal_NORMAL_TRANSFORM }   
              scale                   CVTF_ArmazonFrontal_max_extent/CVTF_ArmazonLateral_max_extent*<1,0,1>+y
              rotate                  90*y
              rotate                  90*z
              translate               -( FactorAnchoLargo-1.1*CVTF_ArmazonFrontal_width/CVTF_ArmazonLateral_max_extent )*z/2      
              scale                   <1,1,-1>
            }                          
          }
      } 
    #local AsientoPosterior         =       
      intersection                  {
          object                    {
            CVTF_AsientoPosteriorLateral 
            transform             { CVTF_ArmazonLateral_NORMAL_TRANSFORM }   
            rotate                  -90*x  
          } 
          union                     {                       
            object                    {  
              CVTF_AsientoPosteriorSuperior  
              transform             { CVTF_ArmazonSuperior_NORMAL_TRANSFORM }   
              translate             -( FactorAnchoLargo-CVTF_ArmazonSuperior_height/CVTF_ArmazonSuperior_width)*z/2
            }                          
            object                    {  
              CVTF_AsientoPosteriorSuperior         
              transform             { CVTF_ArmazonSuperior_NORMAL_TRANSFORM }   
              translate             -( FactorAnchoLargo-CVTF_ArmazonSuperior_height/CVTF_ArmazonSuperior_width)*z/2
              scale                 <1,1,-1>  
            }                          
          }   
          union                     {
            object                    {   
              CVTF_AsientoPosteriorFrontal      
              transform             { CVTF_ArmazonFrontal_NORMAL_TRANSFORM }   
              scale                   CVTF_ArmazonFrontal_max_extent/CVTF_ArmazonLateral_max_extent*<1,0,1>+y
              rotate                  90*y
              rotate                  90*z  
              translate               -( FactorAnchoLargo-1.1*CVTF_ArmazonFrontal_width/CVTF_ArmazonLateral_max_extent )*z/2
            }                          
            object                    {   
              CVTF_AsientoPosteriorFrontal      
              transform             { CVTF_ArmazonFrontal_NORMAL_TRANSFORM }   
              scale                   CVTF_ArmazonFrontal_max_extent/CVTF_ArmazonLateral_max_extent*<1,0,1>+y
              rotate                  90*y
              rotate                  90*z
              translate               -( FactorAnchoLargo-1.1*CVTF_ArmazonFrontal_width/CVTF_ArmazonLateral_max_extent )*z/2      
              scale                   <1,1,-1>
            }                          
          }
      } 
    #local RespaldarDelantero       =       
      intersection                  {
          object                    {
            CVTF_RespaldarDelanteroLateral 
            transform             { CVTF_ArmazonLateral_NORMAL_TRANSFORM }
            rotate                  -90*x       
            translate               -0.025*x                               
            scale                   <2.0,1,1>   
          } 
          union                     {                       
            object                    {  
              CVTF_RespaldarDelanteroSuperior  
              transform             { CVTF_ArmazonSuperior_NORMAL_TRANSFORM }   
              translate             -( FactorAnchoLargo-CVTF_ArmazonSuperior_height/CVTF_ArmazonSuperior_width)*z/2
            }                          
            object                    {  
              CVTF_RespaldarDelanteroSuperior         
              transform             { CVTF_ArmazonSuperior_NORMAL_TRANSFORM }   
              translate             -( FactorAnchoLargo-CVTF_ArmazonSuperior_height/CVTF_ArmazonSuperior_width)*z/2
              scale                 <1,1,-1>  
            }                          
          }   
          union                     {
            object                    {   
              CVTF_RespaldarDelanteroFrontal      
              transform             { CVTF_ArmazonFrontal_NORMAL_TRANSFORM }   
              scale                   CVTF_ArmazonFrontal_max_extent/CVTF_ArmazonLateral_max_extent*<1,0,1>+y
              rotate                  90*y
              rotate                  90*z  
              translate               -( FactorAnchoLargo-1.25*CVTF_ArmazonFrontal_width/CVTF_ArmazonLateral_max_extent )*z/2
            }                          
            object                    {   
              CVTF_RespaldarDelanteroFrontal      
              transform             { CVTF_ArmazonFrontal_NORMAL_TRANSFORM }   
              scale                   CVTF_ArmazonFrontal_max_extent/CVTF_ArmazonLateral_max_extent*<1,0,1>+y
              rotate                  90*y
              rotate                  90*z
              translate               -( FactorAnchoLargo-1.25*CVTF_ArmazonFrontal_width/CVTF_ArmazonLateral_max_extent )*z/2      
              scale                   <1,1,-1>
            }                          
          } 
          rotate                    -15*z
      } 
    #local AsientoDelantero         =       
      intersection                  {
          object                    {
            CVTF_AsientoDelanteroLateral 
            transform             { CVTF_ArmazonLateral_NORMAL_TRANSFORM }   
            rotate                  -90*x  
          } 
          union                     {                       
            object                    {  
              CVTF_AsientoDelanteroSuperior  
              transform             { CVTF_ArmazonSuperior_NORMAL_TRANSFORM }   
              translate             -( FactorAnchoLargo-CVTF_ArmazonSuperior_height/CVTF_ArmazonSuperior_width)*z/2
            }                          
            object                    {  
              CVTF_AsientoDelanteroSuperior         
              transform             { CVTF_ArmazonSuperior_NORMAL_TRANSFORM }   
              translate             -( FactorAnchoLargo-CVTF_ArmazonSuperior_height/CVTF_ArmazonSuperior_width)*z/2
              scale                 <1,1,-1>  
            }                          
          }   
          union                     {
            object                    {   
              CVTF_AsientoDelanteroFrontal      
              transform             { CVTF_ArmazonFrontal_NORMAL_TRANSFORM }   
              scale                   CVTF_ArmazonFrontal_max_extent/CVTF_ArmazonLateral_max_extent*<1,0,1>+y
              rotate                  90*y
              rotate                  90*z  
              translate               -( FactorAnchoLargo-1.25*CVTF_ArmazonFrontal_width/CVTF_ArmazonLateral_max_extent )*z/2
            }                          
            object                    {   
              CVTF_AsientoDelanteroFrontal      
              transform             { CVTF_ArmazonFrontal_NORMAL_TRANSFORM }   
              scale                   CVTF_ArmazonFrontal_max_extent/CVTF_ArmazonLateral_max_extent*<1,0,1>+y
              rotate                  90*y
              rotate                  90*z
              translate               -( FactorAnchoLargo-1.25*CVTF_ArmazonFrontal_width/CVTF_ArmazonLateral_max_extent )*z/2      
              scale                   <1,1,-1>
            }                          
          }
      } 
    #local BaseManivela             =  
      intersection                  {
          object                    {
            CVTF_BaseManivelaLateral 
            transform             { CVTF_ArmazonLateral_NORMAL_TRANSFORM }   
            rotate                  -90*x  
          } 
          union                     {                       
            object                    {  
              CVTF_BaseManivelaSuperior  
              transform             { CVTF_ArmazonSuperior_NORMAL_TRANSFORM }   
              translate             -( FactorAnchoLargo-CVTF_ArmazonSuperior_height/CVTF_ArmazonSuperior_width)*z/2
            }                          
            object                    {  
              CVTF_BaseManivelaSuperior         
              transform             { CVTF_ArmazonSuperior_NORMAL_TRANSFORM }   
              translate             -( FactorAnchoLargo-CVTF_ArmazonSuperior_height/CVTF_ArmazonSuperior_width)*z/2
              scale                 <1,1,-1>  
            }                          
          }   
          union                     {
            object                    {   
              CVTF_RespaldarPosteriorFrontal      
              transform             { CVTF_ArmazonFrontal_NORMAL_TRANSFORM }   
              scale                   CVTF_ArmazonFrontal_max_extent/CVTF_ArmazonLateral_max_extent*<1,0,1>+y
              rotate                  90*y
              rotate                  90*z  
              translate               -( FactorAnchoLargo-1.1*CVTF_ArmazonFrontal_width/CVTF_ArmazonLateral_max_extent )*z/2
            }                          
            object                    {   
              CVTF_RespaldarPosteriorFrontal      
              transform             { CVTF_ArmazonFrontal_NORMAL_TRANSFORM }   
              scale                   CVTF_ArmazonFrontal_max_extent/CVTF_ArmazonLateral_max_extent*<1,0,1>+y
              rotate                  90*y
              rotate                  90*z
              translate               -( FactorAnchoLargo-1.1*CVTF_ArmazonFrontal_width/CVTF_ArmazonLateral_max_extent )*z/2      
              scale                   <1,1,-1>
            }                          
          }
      }   
    #local FractalBajos             =  
        julia_fractal{ <-0.083,0.0,-0.83,-0.025>
           hypercomplex // quaternion, hypercomplex
           sqr              // Types: sqr  cube
           max_iteration 8
           precision 20     // 10...500
           scale<1,1,1>
           rotate<0,0,0>
           translate<0,0,0>
        } // end of julia_fractal ---------- 
    #local Placa                    =
      box                       {    
        -1, 1 
        pigment {    
          image_map             {   
            jpeg CVTF_ImagenPlaca 
          }                
          translate     -1/2
          scale         2    
          rotate        90*y
        }         
        normal {  
          granite 
          scale      0.1
        }  
        scale               <0.002,0.020,0.040>
      } 
    #local BaseLuz                  =  
          superellipsoid            {  
            <1.0,0.2>
            rotate                      90*y
            scale                   <0.0075,0.030,0.030>
          }                          
    #local Retrovisor               =    
    union                           {
       union                        {   
         difference                 {   
           superellipsoid           {    
             <0.5,0.5>          
           } 
           box                      {  
             -1, 1
             scale                  <0.1,0.9,0.9>
           }         
           plane                    {   
             -x, 0
           }
         }   
         difference                 {
           box                      {  
             -1, 1
             scale                  <0.1,0.9,0.9>
           }
           box                      {  
             -1, 1
             scale                  <0.098,0.9,0.9>
           }
           plane                    {   
             -x, 0
           }                              
           texture                  {  
             pigment { Clear }       
             finish                 { 
               ambient 0
               diffuse 0          
               roughness  0
               reflection   { 1 }
             }
           } 
         }                      
         rotate                 5*z
         rotate                 -10*y
       }                       
       cone                       {  
         -0.5, 0.2,
         -1.0, 0.3
         scale              <1,1,-1>
       }         
       sphere                       {   
         -1, 0.3
         scale              <1,1,-1>
       }
       scale                      <0.025,0.025,0.035>*0.75
    }
    #local Retrovisor2              =    
    union                           {
       union                        {   
         difference                 {   
           superellipsoid           {    
             <0.5,0.5>          
           } 
           box                      {  
             -1, 1
             scale                  <0.1,0.85,0.85>
           }         
           plane                    {   
             -x, 0
           }
         }   
         difference                 {
           box                      {  
             -1, 1
             scale                  <0.1,0.85,0.85>
           }
           box                      {  
             -1, 1
             scale                  <0.098,0.85,0.85>
           }
           plane                    {   
             -x, 0
           }                              
           texture                  {  
             pigment { Clear } 
             finish                 { 
               ambient 0
               diffuse 0         
               roughness  0
               reflection   { 1 }
             }
           } 
         }                      
         rotate                 10*z
         rotate                 -20*y
       }                       
       cone                       {  
         -0.5, 0.2,
         -1.0, 0.3
         scale              <1,1,-1>
       }         
       sphere                       {   
         -1.0, 0.3
         scale              <1,1,-1>
       }
       scale                      <0.025,0.025,0.035>*0.75
    }
              
    union                       {    
        difference                  {   
          object                    {
            CarroceriaBase   
          }
          object                    {  
            CarroceriaInterna
          }  
          object                    {   
            BloqueVentanaFrontal
          } 
          object                    {  
            BaseCajuelaDelantera
          }  
          object                    {  
            BaseCajuelaPosterior
          }  
          object                    {   
            BasePuertaDelantera
          }                
          object                    {   
            BasePuertaPosterior
          }
          box                       {  
            <-0.240,-0.150,-0.220>,
            <+0.175,-0.113,+0.220>
          }
        }
      object                    {  
        VentanaFrontal   
        material                {   
          MaterialVidrio
        }
      } 
      object                  { 
        Protectores              
        texture                { TexturaProtector }
      }
      object                    {   
        CajuelaDelantera
      }    
      object                    {    
        CajuelaPosterior
      }   
      union                     {    
        object                  {
          PuertaDelanteraDerecha   
        }     
        object                  {   
          Retrovisor
          translate             -0.18*z-0.11*x+0.05*y  
          scale                 <1,1,-1>
        }
        object                  {   
          BrazoDelantero 
          scale                 <1,1,-1>    
          translate             -0.015*z
          texture               {    
            TexturaBrazo
          }
        }     
        intersection                    {  
          difference                    {
            object                          {  
              BaseVidrioDelantero 
            }       
            plane                       {   
              z, 0
            }
            plane                       {   
              x, -0.125  
              rotate        -40*z
            }        
            translate                   -0.060*y*FraccionAbrirVentanaDerecha                      
          }
          difference                    {    
            object              {  
              CarroceriaBase
              scale             0.995
            }                        
            object              {  
              CarroceriaInterna 
              scale             0.980
            }
          }       
          material                      {    
            MaterialVidrio
          }
        }  
        translate               -EjePuertaDelanteraDerecha
        rotate                  -GiroPuertaDelanteraDerecha*y 
        translate               +EjePuertaDelanteraDerecha
      } 
      union                    { 
        object                 { 
          PuertaDelanteraDerecha  
        }   
        object                  {   
          Retrovisor2
          translate             -0.18*z-0.11*x+0.05*y
          scale                 <1,1,-1>
        }
        object                  {   
          BrazoDelantero 
          scale                 <1,1,-1>    
          translate             -0.015*z
          texture               {    
            TexturaBrazo
          }
        }      
        intersection                    {  
          difference                    {
            object                          {  
              BaseVidrioDelantero 
            }       
            plane                       {   
              z, 0
            }
            plane                       {   
              x, -0.125  
              rotate        -40*z
            }        
            translate                   -0.060*y*FraccionAbrirVentanaIzquierda                     
          }
          difference                    {    
            object              {  
              CarroceriaBase
              scale             0.995
            }                        
            object              {  
              CarroceriaInterna 
              scale             0.980
            }
          }            
          material                      {   
            MaterialVidrio
          }
        }     
        translate               -EjePuertaDelanteraDerecha
        rotate                  -GiroPuertaDelanteraIzquierda*y 
        translate               +EjePuertaDelanteraDerecha
        scale                   <1,1,-1>
      } 
      union                             {
        object                          { 
          PuertaPosteriorDerecha           
        }  
        object                  {   
          BrazoPosterior 
          scale                 <1,1,-1>    
          translate             -0.015*z
          texture               {    
            TexturaBrazo
          }
        } 
        intersection                    {  
          difference                    {
            object                          {  
              BaseVidrioPosterior 
            }       
            plane                       {   
              z, 0
            }
          }
          difference                    {    
            object              {  
              CarroceriaBase
              scale             0.995
            }                        
            object              {  
              CarroceriaInterna 
              scale             0.980
            }
          }       
          material                      {      
            MaterialVidrio
          }
        }   
        intersection                    {  
          difference                    {
            object                          {  
              BaseVidrioPosterior2 
            }       
            plane                       {   
              z, 0
            }
          }
          difference                    {    
            object              {  
              CarroceriaBase
              scale             0.995
            }                        
            object              {  
              CarroceriaInterna 
              scale             0.980
            }
          }       
          material                      {    
            MaterialVidrio
          }
        }  
        translate               -EjePuertaPosteriorDerecha
        rotate                  -GiroPuertaPosteriorDerecha*y 
        translate               +EjePuertaPosteriorDerecha
      } 
      union                     { 
        object                  {  
          PuertaPosteriorDerecha   
        } 
        object                  {   
          BrazoPosterior 
          scale                 <1,1,-1>    
          translate             -0.015*z
          texture               {    
            TexturaBrazo
          }
        } 
        intersection                    {  
          difference                    {
            object                          {  
              BaseVidrioPosterior 
            }       
            plane                       {   
              z, 0
            }
          }
          difference                    {    
            object              {  
              CarroceriaBase
              scale             0.995
            }                        
            object              {  
              CarroceriaInterna 
              scale             0.980
            }
          }       
          material                      {
            MaterialVidrio
          }  
        }   
        intersection                    {  
          difference                    {
            object                          {  
              BaseVidrioPosterior2 
            }       
            plane                       {   
              z, 0
            }
          }
          difference                    {    
            object              {  
              CarroceriaBase
              scale             0.995
            }                        
            object              {  
              CarroceriaInterna 
              scale             0.980
            }
          }            
          material                      {
            MaterialVidrio
          }  
        }   
        translate               -EjePuertaPosteriorDerecha
        rotate                  -GiroPuertaPosteriorIzquierda*y 
        translate               +EjePuertaPosteriorDerecha
        scale                   <1,1,-1>
      } 
      object                    {    
        Motor
      }                        
    }   
    // Interior
    union                       {      
      union                     {
          object                    {  
            RespaldarDelantero
            texture                 {   
              TexturaRespaldar
            }
          } 
          object                    {  
            AsientoDelantero       
            translate               -0.01*x
            texture                 {   
              TexturaRespaldar
            }
          } 
          translate             +0.0375*x                         
      }
      object                    {  
        RespaldarPosterior
        texture                 {   
          TexturaRespaldar
        }
      } 
      object                    {  
        AsientoPosterior
        texture                 {   
          TexturaRespaldar
        }
      }
      object                    {   
        BaseManivela
        texture                 {    
          TexturaBrazo
        }
      }    
    }
    // Ruedas 
    union                       { 
      object                    {    
        Pneu       
        rotate                  90*x    
        rotate                  AnguloRodar*z
        rotate                  GiroRuedasDelanteras*y
        scale                   0.0075*<1,1,1.5>
        translate               PosRuedaDelanteraDerecha
      }
      object                    {    
        Pneu       
        rotate                  90*x         
        rotate                  20*z
        rotate                  AnguloRodar*z
        rotate                  -GiroRuedasDelanteras*y
        scale                   0.0075*<1,1,1.5>
        translate               PosRuedaDelanteraDerecha    
        scale                   <1,1,-1>
      }
      object                    {    
        Pneu       
        rotate                  90*x 
        rotate                  227*z   
        rotate                  AnguloRodar*z
        scale                   0.0075*<1,1,1.5>
        translate               PosRuedaPosteriorDerecha
      }
      object                    {    
        Pneu       
        rotate                  90*x         
        rotate                  120*z
        rotate                  AnguloRodar*z
        scale                   0.0075*<1,1,1.5>
        translate               PosRuedaPosteriorDerecha    
        scale                   <1,1,-1>
      } 
    }  
    // Manivela
    union                       {     
      torus                     {    
        0.04, 0.005
        rotate                  90*z
      }            
      cylinder                  {  
        -0.01*x, 0.04*y, 0.005      
        rotate                  15*x
      }
      cylinder                  {  
        -0.01*x, 0.04*y, 0.005       
        rotate                  135*x
      }
      cylinder                  {  
        -0.01*x, 0.04*y, 0.005        
        rotate                  255*x
      }
      cylinder                  {     
        0, -0.1*x, 0.006   
        translate               -0.01*x
      }                           
      rotate                    +30*z       
      translate                 -0.100*x+0.020*y   
      #if ( CVTF_ManivelaDerechaIzquierda )  
        translate               +0.065*z
      #else  // #else ( CVTF_ManivelaDerechaIzquierda ) 
        translate               -0.065*z
      #end   // #else ( CVTF_ManivelaDerechaIzquierda )
      texture                   {   
        TexturaManivela
      }
    }  
    // Bajos
    union                       {    
      box                       {  
        <-0.240,-0.110,-0.180>,
        <+0.175,-0.109,+0.180>
        texture                 { 
          TexturaBrazo 
        }
      }
      box                       {  
        <-0.240,-0.110,-0.180>,
        <+0.175,-0.111,+0.180>
      }
      cylinder                  {                              
        -0.130*z, 0.130*z, 0.01
        translate               PosRuedaDelanteraDerecha*<1,1,0>
      }             
      cylinder                  {                              
        -0.150*z, 0.150*z, 0.01
        translate               PosRuedaPosteriorDerecha*<1,1,0>
      } 
      object                    {   
        FractalBajos
        scale                   0.05
        rotate                  -45*y
        scale                   <2,0.75,1.5>
        translate               PosRuedaDelanteraDerecha*<1,1,0>
      }            
      object                    {   
        FractalBajos
        scale                   0.05
        rotate                  0*y
        scale                   <2,1,0.5>
        translate               PosRuedaDelanteraDerecha*<1,1,0.75>
      }            
      object                    {   
        FractalBajos
        scale                   0.05
        rotate                  0*y
        scale                   <2,1,0.5>
        translate               PosRuedaDelanteraDerecha*<1,1,-0.75>
      }            
      object                    {   
        FractalBajos
        scale                   0.05
        rotate                  -45*y
        scale                   <2,0.75,1.5>
        translate               PosRuedaPosteriorDerecha*<1,1,0>
      }            
      object                    {   
        FractalBajos
        scale                   0.05
        rotate                  0*y
        scale                   <2,1,0.5>
        translate               PosRuedaPosteriorDerecha*<1,1,0.75>
      }            
      object                    {   
        FractalBajos
        scale                   0.05
        rotate                  0*y
        scale                   <2,1,0.5>
        translate               PosRuedaPosteriorDerecha*<1,1,-0.75>
      }            
      texture                   {  
        TexturaBajos
      }   
    }   
    // Placa      
    union                       { 
      object                    {
        Placa
        translate               -0.495*x-0.100*y
      }      
      object                    { 
        Placa
        rotate                  180*y
        translate               +0.495*x-0.060*y
      }
    }          
    // Luces
    union                       {  
      union                { 
        object              {
          BaseLuz           
          scale                 0.99
          texture                 { TexturaFondoBombillo }  
        }                                
        object              {  
          BaseLuz
          texture               { TexturaBombillo }
        }  
        translate               PosLuzDelanteraDerecha
      }
      union                { 
        object              {
          BaseLuz           
          scale                 0.99
          texture                 { TexturaFondoBombillo }  
        }                                
        object              {  
          BaseLuz
          texture               { TexturaBombillo }
        }  
        translate               PosLuzDelanteraDerecha*<1,1,-1>
      }
      union                { 
        object              {  
          BaseLuz                            
          scale                 <1,0.5,0.5>
          texture               { TexturaManivela }
        }  
        translate               PosLuzDelanteraDerecha*<1,1,0.5>
      }
      union                { 
        object              {  
          BaseLuz               
          scale                 <1,0.5,0.5>
          texture               { TexturaManivela }
        }  
        translate               PosLuzDelanteraDerecha*<1,1,-0.5>
      }
      union                { 
        object              {  
          BaseLuz                            
          scale                 <1,0.75,0.75>*0.95
          texture               { TexturaFondoBombilloPosterior }
        }  
        object              {  
          BaseLuz                            
          scale                 <1,0.75,0.75>
          texture               { TexturaBombillo }
        }  
        translate               PosLuzPosteriorDerecha*<1,1,1>
      }
      union                { 
        object              {  
          BaseLuz                            
          scale                 <1,0.75,0.75>*0.95
          texture               { TexturaFondoBombilloPosterior }
        }  
        object              {  
          BaseLuz               
          scale                 <1,0.75,0.75>
          texture               { TexturaBombillo }
        }  
        translate               PosLuzPosteriorDerecha*<1,1,-1>
      }
    }         
    translate                  +0.1595*y       
    texture                    { TexturaPrincipal } 
    scale                       LargoFundamental
  }
#end  // #macro CVTF_CarroVehicularTetraFord               
               
#macro CVTF_Carro( )
  object                        {   
    CVTF_CarroVehicularTetraFord( 0, 0, 0, 0, 0, 0, 0, 0 )
  }
#end  // #macro CVTF_Carro