// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho...  19 mayo 2015
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY
//     
// CDTC CocinaDiscoTransferenciaCalor
// El archivo dibuja una cocina de uso domestico electrica.
// Es muy poco flexible, pero incluye una macro para modificar 
// algunas de sus caracteristicas principales.
// Es compatible con POVRay 3.1.
//
// La macro principal tiene unicamente un parametro  
// #macro CDTC_Cocina( AnguloPuerta )   
//      AnguloPuerta            : Angulo para abrir la puerta del horno.
//
// La siguiente macro permite un mayor control de las caracteristicas.
// #macro CDTC_CocinaDiscoTransferenciaCalor( AnguloPuerta, AnguloPerillas
//                FrenteFundamental, AltoFundamental, ProfundidadFundamental,
//                AltoHorno, LateralHorno, BaseHorno, AltoBotones,
//                ProfundidadPuerta, AltoSuperior, ProfundidadSuperior,
//                SeparacionDiscos, DiametroDiscos, ArregloTexturas )
//      AnguloPuerta            : Angulo para abrir la puerta del horno.
//      AnguloPerillas          : array [5] de angulos en grados para girar las perillas
//              numeradas de izquierda a derecha, vistas desde el frente.
//              Por defecto su valor es CDTC_PerillasApagadas, todas en 0.
//      FrenteFundamental       : Frente del horno. Valor por defecto 365*L.
//      AltoFundamental         : Referencia para el alto del horno.
//              Valor por defecto 636*L.
//      ProfundidadFundamental  : Referencia para la profundidad del horno.
//              Valor por defecto 330*L.
//      AltoHorno               : Referencia para el tamano de abertura del horno.
//              Valor por defecto 272*L.
//      LateralHorno            : Referencia para el grueso de las paredes laterales
//              internas del horno. Valor por defecto 38*L.
//      BaseHorno               : Referencia para el grosor inferior desde la base
//              para ubicar el horno. Valor por defecto 250*L.
//      AltoBotones             : Alto en Y para el panel de botones.
//              Valor por defecto 71*L.
//      ProfundidadPuerta       : Referencia para el grosor de la puerta.
//              Valor por defecto 32*L.
//      AltoSuperior            : Referencia para el alto del panel superior de la cocina.
//              Valor por defecto 21*L.
//      ProfundidadSuperior     : Referencia para la profundidad Z del panel superior.
//              Valor por defecto 372*L.
//      SeparacionDiscos        : Separacion centro a centro entre discos.
//              Valor por defecto 164*L.
//      DiametroDiscos          : Diametro de los discos de calentamiento.
//              Valor por defecto 114*L.     
//      ArregloTexturas         : array [ 7 ] de texturas, en el siguiente orden:
//              { TexturaPrincipal, TexturaHorno, TexturaMetal, 
//                TexturaDiscos, TexturaVentanaHorno, TexturaPerilla, TexturaSuperior }.
//              Por defecto tienen asignado los siguientes valores:
//              { CDTC_TexturaPrincipal, CDTC_TexturaHorno, CDTC_TexturaMetal,
//                CDTC_TexturaDiscos, CDTC_TexturaVentanaHorno, 
//                CDTC_TexturaPerilla, CDTC_TexturaSuperior }     
//                      TexturaPrincipal        : Textura principal del aparato.
//                      TexturaHorno            : Se aplica al horno   
//                      TexturaMetal            : Partes metalizadas
//                      TexturaDiscos           : Discos de calentamiento   
//                      TexturaVentanaHorno     : Ventanilla del horno
//                      TexturaPerilla          : Perillas de ajuste
//                      TexturaSuperior         : Panel de exposicion   
//
// La cocina se encuentra completamente contenida en las siguientes coordenadas.
//      Minimo  = <-183,   0, -390 >*L
//      Maximo  = < 183, 810,   55 >*L
// Frente hacia Z-, gravedad hacia Y-. Piso en plano XZ.
// El plano XY sirve de base a la estructura principal, pero el panel
// superior sobresale en Z+.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.  
// #declare CDTC_DefaultTexturaPrincipal  
//      Textura principal del aparato.
// #declare CDTC_DefaultTexturaHorno       
//      Textura del horno.
// #declare CDTC_DefaultTexturaMetal            
//      Textura de partes metalizadas.
// #declare CDTC_DefaultTexturaDiscos       
//      Textura de los discos de calentamiento.
// #declare CDTC_DefaultTexturaVentanaHorno
//      Textura ventanilla del horno.
// #declare CDTC_DefaultTexturaPerilla             
//      Textura de las perillas de control.   
// #declare CDTC_DefaultTexturaSuperior            
//      Textura del panel superior.  
// #declare CDTC_PerillasApagadas               = array [ 5 ] { 0,0,0,0,0 }
//      Perillas por defecto, todas en posicion off. 
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)   
// #declare CDTC_TexturaPrincipal               = texture { ... }                 
//      Textura principal del aparato.
// #declare CDTC_TexturaHorno                   = texture { ... }
//      Textura del horno.                                   
// #declare CDTC_TexturaMetal                   = texture { ... }
//      Textura de partes metalizadas.
// #declare CDTC_TexturaDiscos                  = texture { ... }   
//      Textura de los discos de calentamiento.                     
// #declare CDTC_TexturaVentanaHorno            = texture { ... }
//      Textura ventanilla del horno.
// #declare CDTC_TexturaPerilla                 = texture { ... }
//      Textura de las perillas de control.
// #declare CDTC_TexturaSuperior                = texture { ... }
//      Textura del panel superior.                               
// #declare CDTC_POV3_1                                 = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//
// Para colocarlo simplemente
// #include "CDTC.inc"
// object        { CDTC_Cocina( 0 ) }
//                           
// Ejemplo con la macro detallada, mismo objeto default
// #include "CDTC.inc"   
// #local ArregloTexturas            = array [ 7 ]
//                { CDTC_TexturaPrincipal, CDTC_TexturaHorno,
//                  CDTC_TexturaMetal, CDTC_TexturaDiscos,
//                  CDTC_TexturaVentanaHorno, CDTC_TexturaPerilla,
//                  CDTC_TexturaSuperior }         
// object                       {
//   CDTC_CocinaDiscoTransferenciaCalor( 0, CDTC_PerillasApagadas,
//              0.365, 0.636, 0.330, 0.272, 0.038, 0.250, 0.071,
//              0.032, 0.021, 0.372, 0.164, 0.114, ArregloTexturas )
// }
//        
// Con modificadores
// #include "CDTC.inc"
// #include "textures.inc"
// #declare CDTC_TexturaPrincipal   = PinkAlabaster
// object        { CDTC_Cocina( 0 ) }
//
#include "CDTC_AU1.inc"
#include "colors.inc"
#include "stones.inc"
#include "textures.inc"
#declare CDTC_L                 = 0.001; 

#declare CDTC_PerillasApagadas               = array [ 5 ] { 0,0,0,0,0 }


#declare CDTC_DefaultTexturaPrincipal   =
  texture                               {
    pigment                             {
      White
    }
    finish                              {
      metallic
    }
  }

#ifndef ( CDTC_TexturaPrincipal )
  #declare CDTC_TexturaPrincipal        = CDTC_DefaultTexturaPrincipal
#end  // #ifndef ( CDTC_TexturaPrincipal )

#declare CDTC_DefaultTexturaHorno       =
  texture                               {
    T_Stone22
  }

#ifndef ( CDTC_TexturaHorno )
  #declare CDTC_TexturaHorno            = CDTC_DefaultTexturaHorno
#end  // #ifndef ( CDTC_TexturaHorno )

#declare CDTC_DefaultTexturaVentanaHorno       =
  texture                               {
    pigment                             {
      gradient y
      scale                     0.05
      pigment_map                       {
        [ 0.0 Clear ]
        [ 0.9 Clear ]
        [ 0.9 Gray20 ]
        [ 1.0 Gray20 ]
      }
    }
  }
  texture                               {
    pigment                             {
      quilted
      translate                         -0.5
      scale                             1.8
      pigment_map                       {
        [ 0.0 Clear ]
        [ 0.7 Gray05 ]
        [ 1.0 Gray05 ]
      }
    }
  }

#ifndef ( CDTC_TexturaVentanaHorno )
  #declare CDTC_TexturaVentanaHorno            = CDTC_DefaultTexturaVentanaHorno
#end  // #ifndef ( CDTC_TexturaVentanaHorno )

#declare CDTC_DefaultTexturaMetal       =
  texture                               {
    Polished_Chrome
  }

#ifndef ( CDTC_TexturaMetal )
  #declare CDTC_TexturaMetal            = CDTC_DefaultTexturaMetal
#end  // #ifndef ( CDTC_TexturaMetal )

#declare CDTC_DefaultTexturaDiscos      =
  texture                               {
    T_Stone31
    normal                              {
      onion
      scale                     0.01
      turbulence                0.2
    }
  }

#ifndef ( CDTC_TexturaDiscos )
  #declare CDTC_TexturaDiscos           = CDTC_DefaultTexturaDiscos
#end  // #ifndef ( CDTC_TexturaDiscos )

#declare CDTC_DefaultTexturaPerilla     =
  texture                               {
    T_Stone35
    normal                              {
      onion
      scale                     0.01
      turbulence                0.2
    }
  }

#ifndef ( CDTC_TexturaPerilla )
  #declare CDTC_TexturaPerilla          = CDTC_DefaultTexturaPerilla
#end  // #ifndef ( CDTC_TexturaPerilla )

#declare CDTC_DefaultTexturaSuperior    =
  texture                               {
    brick texture { CDTC_DefaultTexturaPerilla },
          texture { CDTC_DefaultTexturaPrincipal }
    mortar                        0.1
    scale 0.04
  }

#ifndef ( CDTC_TexturaSuperior )
  #declare CDTC_TexturaSuperior         = CDTC_DefaultTexturaSuperior
#end  // #ifndef ( CDTC_TexturaSuperior )    

#macro CDTC_RejillaHorno( Largo, Ancho, Grueso )
  union                                         {
    #local ArregloRejilla               = array [ 4 ]
                { <+Largo/2,0,+Ancho/2>,
                  <-Largo/2,0,+Ancho/2>,
                  <-Largo/2,0,-Ancho/2>,
                  <+Largo/2,0,-Ancho/2> }
    object                              {
      CDTC_SweepBezierCerrado( ArregloRejilla, Grueso/2, 0.3 )
    }
    #local TotalBarritas                = 11;
    #local C                            = 0;
    #while ( C < TotalBarritas )
      cylinder                            {
        -Ancho/2*z, +Ancho/2*z, Grueso/4
        translate               0.75*Grueso*z
        translate               ( ( TotalBarritas-1 )/2-C )*Largo*x/TotalBarritas
      }
      #local C                          = C+1;
    #end
  }
#end

#macro CDTC_CocinaDiscoTransferenciaCalor( AnguloPuerta, AnguloPerillas
                FrenteFundamental, AltoFundamental, ProfundidadFundamental,
                AltoHorno, LateralHorno, BaseHorno, AltoBotones,
                ProfundidadPuerta, AltoSuperior, ProfundidadSuperior,
                SeparacionDiscos, DiametroDiscos, ArregloTexturas )
  union                                 {
    #local TexturaPrincipal             = ArregloTexturas[ 0 ]
    #local TexturaHorno                 = ArregloTexturas[ 1 ]
    #local TexturaMetal                 = ArregloTexturas[ 2 ]
    #local TexturaDiscos                = ArregloTexturas[ 3 ]
    #local TexturaVentanaHorno          = ArregloTexturas[ 4 ]
    #local TexturaPerilla               = ArregloTexturas[ 5 ]
    #local TexturaSuperior              = ArregloTexturas[ 6 ]
    #local FrenteHorno                  = FrenteFundamental-2*LateralHorno;
    #local LateralBlanco                = 7/38*LateralHorno;
    #local LibreInferior                = 29*BaseHorno/250;
    #local LibrePuerta                  = 7*ProfundidadPuerta/32;
    #local BasePuerta                   = 214*BaseHorno/250;
    #local ProfundidadExtraSuperior     = 25/32*ProfundidadPuerta;
    #local ProfundidadFondo             = ProfundidadFundamental*40/330;
    #local AltoFondo                    = AltoFundamental*154/636;
    #local TotalDiscosHorizontal        =
        div( FrenteFundamental, SeparacionDiscos );
    #local TotalDiscosVertical          =
        div( ProfundidadFundamental, SeparacionDiscos );
    #local TotalPerillas                = dimension_size( AnguloPerillas, 1 );
    difference                          {
      box                               {
        < -FrenteFundamental/2, 0, -ProfundidadFundamental/2 >,
        < +FrenteFundamental/2, AltoFundamental,
                +ProfundidadFundamental/2 >
      }
      box                               {
        < -FrenteFundamental/2+LateralBlanco, BaseHorno/2,
                +0.99*ProfundidadFundamental/2 >,
        < +FrenteFundamental/2-LateralBlanco, 0.95*AltoFundamental,
                -ProfundidadFundamental >
      }
      
      texture                           {
        TexturaPrincipal
      }
      translate                         -ProfundidadFundamental*z/2
    }
    difference                          {
      box                               {
        < -FrenteFundamental/2+LateralBlanco, BaseHorno/2,
                +0.99*ProfundidadFundamental/2 >,
        < +FrenteFundamental/2-LateralBlanco, 0.95*AltoFundamental,
                -ProfundidadFundamental/2 >
      }
      superellipsoid                    {
        <0.1,0.1>
        scale                   < FrenteHorno/2, AltoHorno/2,
                                        ProfundidadFundamental/2 >
        translate               ( AltoHorno/2+BaseHorno )*y
        translate               -5*ProfundidadFundamental/330*z
      }
      texture                           {
        TexturaHorno
      }
      translate                         -ProfundidadFundamental*z/2
    }
    // Rejilla
    union                               {
      object                            {
        CDTC_RejillaHorno( FrenteHorno, ProfundidadFundamental*0.8,
                        0.02*AltoHorno )
        translate       ( AltoHorno/2+BaseHorno )*y
                        -ProfundidadFundamental*z/2
      }
      object                            {
        CDTC_RejillaHorno( FrenteHorno, ProfundidadFundamental*0.8,
                        0.02*AltoHorno )
        translate       ( AltoHorno/10+BaseHorno )*y
                        -ProfundidadFundamental*z/2
      }
      texture                           {
        TexturaMetal
      }
    }
    // Estructura delantera
    union                               {
      #local ArregloBasePuertaL         = array [5]     {
                  < 0, LibreInferior >,
                  < 0, BasePuerta >,
                  < 0.8*ProfundidadPuerta, BasePuerta >,
                  < 1.2*ProfundidadPuerta, 0.6*LibreInferior+0.4*BasePuerta >,
                  < 0.8*ProfundidadPuerta, LibreInferior >
                }
      #local ArregloPanelBotones        = array [4]     {
                  < 0, AltoFundamental-AltoBotones, 1.2 >,
                  < 0, AltoFundamental, 1.2 >,
                  < ProfundidadPuerta, AltoFundamental, 1.2 >,
                  < 2*ProfundidadPuerta, AltoFundamental-AltoBotones, 1.2 >
                }
      difference                        {
        object                            {
          CDTC_PrismaBezierMedio( ArregloBasePuertaL, false,
                -FrenteFundamental/2, +FrenteFundamental/2 )
          rotate                  90*z
          rotate                  -90*x
        }
        plane                   {
          -z, LibrePuerta
        }
      }
      difference                        {
        object                            {
          CDTC_PrismaBezier( ArregloPanelBotones, false,
                -FrenteFundamental/2, +FrenteFundamental/2 )
          rotate                  90*z
          rotate                  -90*x
        }
        plane                   {
          -z, LibrePuerta
        }
      }
      // Relleno inferior
      box                       {
        < -0.95*FrenteFundamental/2, 0.9*LibreInferior+0.1*BasePuerta, 0 >,
        < +0.95*FrenteFundamental/2, 0.1*LibreInferior+0.9*BasePuerta,
                        -LibrePuerta >
        texture                 {
          TexturaHorno
        }
      }
      // Relleno superior
      box                       {
        < -0.95*FrenteFundamental/2, AltoFundamental-0.1*AltoBotones, 0 >,
        < +0.95*FrenteFundamental/2, AltoFundamental-0.9*AltoBotones,
                        -LibrePuerta >
        texture                 {
          TexturaHorno
        }
      }
      
      // Puerta
      union                     {
        #local ArregloAgarradera        = array [5]
                {
                  < -FrenteFundamental/2,0,1 >,
                  < +FrenteFundamental/2,0,1 >,
                  < +FrenteFundamental/2,-ProfundidadPuerta, 1 >,
                  < 0, -2*ProfundidadPuerta, 1 >,
                  < -FrenteFundamental/2,-ProfundidadPuerta, 1 >
                }
          #local PrismaAgarradera       =
                object              {
                  CDTC_PrismaBezier( ArregloAgarradera, false,
                         0, 0.95*LateralHorno )
                }
        difference              {
          object                {
            PrismaAgarradera
          }
          object                {
            PrismaAgarradera
            scale               0.9
            translate           -0.1*ProfundidadPuerta*z-0.05*LateralHorno*y
          }
          translate             ( -LateralHorno+
                        AltoFundamental-AltoBotones-BasePuerta )*y
        }
        // Ventana Horno
        box                     {
          <-1,-1,-1> , <1,1,-LibrePuerta/ProfundidadPuerta>
          texture { TexturaVentanaHorno }
          scale               < 0.9*FrenteFundamental/2,
                        0.65*( AltoFundamental-BasePuerta-AltoBotones )/2,
                        0.9*ProfundidadPuerta>
          translate       ( AltoFundamental-BasePuerta-AltoBotones )/2*y
        }
        difference              {
          superellipsoid        {
            <0.1,0.1>
            scale               < FrenteFundamental/2,
                        0.925*( AltoFundamental-BasePuerta-AltoBotones )/2,
                        ProfundidadPuerta>
            translate       ( AltoFundamental-BasePuerta-AltoBotones )/2*y
          }
          superellipsoid        {
            <0.1,0.1>
            scale               < 0.9*FrenteFundamental/2,
                        0.65*( AltoFundamental-BasePuerta-AltoBotones )/2,
                        2*ProfundidadPuerta>
            translate       ( AltoFundamental-BasePuerta-AltoBotones )/2*y
          }
          plane                 {
            -z, LibrePuerta
          }
        }
        cylinder                {
          -0.90*FrenteFundamental/2*x,
          +0.90*FrenteFundamental/2*x,
          ProfundidadPuerta/6
          translate             +ProfundidadPuerta/2*<0,+1,-1>
          texture { TexturaHorno }
        }
        difference              {
          box                     {
            -1,1
            scale               < 0.9*FrenteFundamental/2,
                        0.8*( AltoFundamental-BasePuerta-AltoBotones )/2,
                        LibrePuerta >
            translate       ( AltoFundamental-BasePuerta-AltoBotones )/2*y
          }
          box                     {
            -1,1
            scale               < 0.85*FrenteFundamental/2,
                        0.75*( AltoFundamental-BasePuerta-AltoBotones )/2,
                        2*LibrePuerta >
            translate       ( AltoFundamental-BasePuerta-AltoBotones )/2*y
          }
          plane                 {
            -z, 0
          }
          texture               { TexturaHorno }
        }
        difference                      {
          cylinder                      {
            -0.90*FrenteFundamental/2*x,
            +0.90*FrenteFundamental/2*x,
            1.5*ProfundidadPuerta
          }
          cylinder                      {
            -FrenteFundamental/2*x,
            +FrenteFundamental/2*x,
            1.0*ProfundidadPuerta
          }
          cylinder                      {
            -0.875*FrenteFundamental/2*x,
            +0.875*FrenteFundamental/2*x,
            3*ProfundidadPuerta
          }
          plane                         {
            z, 0
          }
          translate                     +ProfundidadPuerta/2*z*<0,+1,-1>
          texture                       {
            TexturaHorno
          }
        }
        translate               ProfundidadPuerta/2*<0,-1,+1>
        rotate                  -AnguloPuerta*x
        translate               ProfundidadPuerta/2*<0,+1,-1>
        translate               BasePuerta*y
      }
      // Perillas
      #local Perilla            =
        union                   {
          difference            {
            sphere              {
              0, AltoBotones/4
              scale             < 1, 1, 0.25 >
            }
            sphere              {
              0, AltoBotones/6
              scale             < 1, 1, 0.25 >
              translate         -0.25*AltoBotones/4*z
            }
            plane               {
              -z, 0.025*AltoBotones
            }
          }
          difference            {
            cylinder              {
              0, -ProfundidadPuerta*z/3, AltoBotones/6
            }
            cylinder              {
              +ProfundidadPuerta*z, -ProfundidadPuerta*z, AltoBotones
              translate         AltoBotones*x*( +1.05 )
            }
            cylinder              {
              +ProfundidadPuerta*z, -ProfundidadPuerta*z, AltoBotones
              translate         AltoBotones*x*( -1.05 )
            }
          }
        }
      #local AnguloPerillasR    = atan2( ProfundidadPuerta, AltoBotones );
      #local SeparacionPerillas = ( FrenteFundamental-2*AltoBotones )/( TotalPerillas-1 );
      #local C                  = 0;
      #while ( C < TotalPerillas )
        object                  {
          Perilla
          texture               {
            TexturaPerilla
          }
          rotate                ( AnguloPerillas[C]+90 )*z
          translate             -0.5*AltoBotones/cos( AnguloPerillasR )*y
          rotate                +degrees( AnguloPerillasR )*x
          translate             -ProfundidadPuerta*z
          translate             AltoFundamental*y
          #if ( C = 0 )
            translate           +( -FrenteFundamental/2+1.5*AltoBotones/2 )*x
          #else  // #else ( C = 0 )
            translate           -( -FrenteFundamental/2+1.5*AltoBotones/2 )*x
            translate           -SeparacionPerillas*x*( TotalPerillas-2 )
            translate           +SeparacionPerillas*x*( C-1 )
          #end   // #else ( C = 0 )
        }
        #local C                = C+1;
      #end  // #while ( C < TotalPerillas )
      texture                   {
        TexturaPrincipal
      }
      translate                         -ProfundidadFundamental*z
    }  // Estructura delantera
    // EstructuraSuperior
    union                               {
      #local ArregloFondo               = array [5]
                {
                  < 0, 0 >,
                  < 0, AltoSuperior+AltoFondo >,
                  < ProfundidadFondo, AltoSuperior+AltoFondo >,
                  < 1.5*ProfundidadFondo, AltoSuperior+0.4*AltoFondo >,
                  < ProfundidadFondo, 0 >,
                }
      object                            {
        CDTC_PrismaBezierMedio( ArregloFondo, false,
                -FrenteFundamental/2, +FrenteFundamental/2 )
        rotate                  90*z
        rotate                  -90*x
        translate               +( ProfundidadSuperior/2+ProfundidadFondo )*z
        texture                         { TexturaSuperior }
      }
      difference                        {
        superellipsoid                  {
          <0.1,0.1>
          scale                 < FrenteFundamental/2,AltoSuperior,ProfundidadSuperior/2>
        }
        superellipsoid                  {
          <0.3,0.3>
          scale                 0.9*< FrenteFundamental/2,0.9*AltoSuperior,ProfundidadSuperior/2>
          translate                     AltoSuperior*y
        }
        plane                           {
          y, LibrePuerta*0.2
        }
      }
      box                               {
        <-FrenteFundamental/2*0.975, 0, -0.975*ProfundidadSuperior/2 >,
        <+FrenteFundamental/2*0.975, 0.2*LibrePuerta, +0.975*ProfundidadSuperior/2 >
        texture { TexturaHorno }
      }
      #local C                          = 0;
      #while ( C < TotalDiscosHorizontal )
        #local D                        = 0;
        #while ( D < TotalDiscosVertical )
          #if ( ( C = 0 ) & ( D = 0 ) )
            #local Bigger               = on;
          #else
            #local Bigger               = off;
          #end
          union                         {
            superellipsoid                {
              <1,0.2>
              rotate                      90*x
              scale               <1.025*DiametroDiscos/2,AltoSuperior/2,1.025*DiametroDiscos/2>
            }
            superellipsoid                {
              <1,0.2>
              rotate                      90*x
              scale               <DiametroDiscos/2,1.2*AltoSuperior/2,DiametroDiscos/2>
              texture { TexturaMetal }
            }
            difference                          {
              superellipsoid                    {
                <1,0.4>
                rotate                  90*x
                scale               0.975*<DiametroDiscos/2,1.05*AltoSuperior,DiametroDiscos/2>
              }
              plane                             {
                -y, -AltoSuperior
              }
              sphere                            {
                0, 1
                scale               0.375*<DiametroDiscos/2,0.5*AltoSuperior,DiametroDiscos/2>
                translate                       AltoSuperior*y
              }
              texture                           {
                TexturaDiscos
                rotate  30*C+150*D
              }
            }
            #if ( Bigger )
              scale                   <136/114,1,136/114>
            #end  // #if ( Bigger )
            translate                   -C*SeparacionDiscos*x
            translate       +SeparacionDiscos*x*( TotalDiscosHorizontal-1 )/2
            translate                   +D*SeparacionDiscos*z
            translate       -SeparacionDiscos*z*( TotalDiscosVertical-1 )/2
          }
          #local D                      = D+1;
        #end  // #while ( D < TotalDiscosVertical )
        #local C                        = C+1;
      #end  // #while ( C < TotalDiscosHorizontal )
      translate                         AltoFundamental*y+
                                        ProfundidadSuperior/2*z
                                        -ProfundidadFundamental*z
                                        -ProfundidadExtraSuperior*z
    }
    texture                             {
      TexturaPrincipal
    }
  }
#end  // #macro CDTC_CocinaDiscoTransferenciaCalor

#macro CDTC_Cocina( AnguloPuerta )
  object                                {
    #local L                            = CDTC_L;
    #local FrenteFundamental            = 365*L;
    #local AltoFundamental              = 636*L;
    #local ProfundidadFundamental       = 330*L;
    #local AltoSuperior                 = 21*L;
    #local ProfundidadSuperior          = 372*L;
    #local AltoHorno                    = 272*L;
    #local LateralHorno                 = 38*L;
    #local BaseHorno                    = 250*L;
    #local AltoBotones                  = 71*L;
    #local ProfundidadPuerta            = 32*L;
    #local SeparacionDiscos             = 164*L;
    #local DiametroDiscos               = 114*L;
    #local UnArregloTexturas            = array [ 7 ]
                { CDTC_TexturaPrincipal, CDTC_TexturaHorno,
                  CDTC_TexturaMetal, CDTC_TexturaDiscos,
                  CDTC_TexturaVentanaHorno, CDTC_TexturaPerilla,
                  CDTC_TexturaSuperior }        
    CDTC_CocinaDiscoTransferenciaCalor( AnguloPuerta, CDTC_PerillasApagadas,
      FrenteFundamental, AltoFundamental, ProfundidadFundamental,
      AltoHorno, LateralHorno, BaseHorno, AltoBotones,
      ProfundidadPuerta, AltoSuperior, ProfundidadSuperior,
      SeparacionDiscos, DiametroDiscos, UnArregloTexturas )
  }
#end  // #macro CDTC_Cocina
