// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho...  19 mayo 2015
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY
//     
// MPCM MartilloParaClavoMetal
// El archivo dibuja un martillo corriente para reparaciones caseras.
// Es muy poco flexible, pero incluye una macro para modificar 
// algunas de sus caracteristicas principales.
// Es compatible con POVRay 3.1.
//
// La macro principal no tiene parametros  
// #macro MPCM_Martillo( )   
//
// La siguiente macro permite un mayor control de las caracteristicas.
// #macro MPCM_MartilloParaClavoMetal( AltoFundamental, AltoCabeza,
//                GruesoFundamental, GruesoLateral, Lateral, LateralPosterior,
//                TexturaMadera, TexturaMetal, TexturaMaderaSuperior )
//      AltoFundamental         : Referencia altura de la base de madera. 
//              Valor por defecto 197*L.      
//      AltoCabeza              : Altura de la cabeza del martillo.
//              Valor por defecto 33.6*L.
//      GruesoFundamental       : Referencia para el grueso del martillo.
//              Valor por defecto 19.3*L.
//      GruesoLateral           : Referencia para el grosor prependicular de la cabeza
//              del martillo en su zona central. Valor por defecto 28.6*L.
//      Lateral                 : Largo del cono de clavar. Valor por defecto 25.0*L.
//      LateralPosterior        : Largo de curva para arrancar clavos.
//              Valor por defecto 25.0*L.
//      TexturaMadera           : Textura de la madera soporte.
//              Valor por defecto MPCM_TexturaMadera.
//      TexturaMetal            : Textura de la cabeza del martillo.
//              Valor por defecto MPCM_TexturaMetal.
//      TexturaMaderaSuperior   : Textura del soporte superior para afirmar la cabeza
//              en la base. Valor por defect MPCM_TexturaMaderaSuperior.           
//
// El martillo se encuentra completamente contenido en las siguientes coordenadas.  
//      Minimo  = <- 40,-200, - 12 >*L
//      Maximo  = <  45,  34,   12 >*L   
// El martillo golpea hacia X+, cabeza hacia Y+ respecto de la base de madera.
// Se ha disenado para que la base de la cabeza metalica en contacto con la madera descanse
// en el plano XZ.                                     
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.  
// #declare MPCM_DefaultTexturaMadera  
//      Textura de la madera soporte.
// #declare MPCM_DefaultTexturaMetal       
//      Textura de la cabeza del martillo.
// #declare MPCM_DefaultTexturaMaderaSuperior         
//      Textura del soporte superior para afirmar la cabeza en la base.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)   
// #declare MPCM_TexturaMadera                  = texture { ... }                 
//      Textura de la madera soporte.
// #declare MPCM_TexturaMetal                   = texture { ... }
//      Textura de la cabeza del martillo.                                   
// #declare MPCM_TexturaMaderaSuperior          = texture { ... }
//      Textura del soporte superior para afirmar la cabeza en la base.
// #declare MPCM_POV3_1                                 = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//
// Para colocarlo simplemente
// #include "MPCM.inc"
// object        { MPCM_Martillo( ) }
//                           
// Ejemplo con la macro detallada, mismo objeto default
// #include "MPCM.inc"   
// object                       {
//   MPCM_MartilloParaClavoMetal( 0.197, 0.0336, 0.0193, 0.0286, 0.025, 0.025,
//              MPCM_TexturaMadera, MPCM_TexturaMetal, MPCM_TexturaMaderaSuperior )
// }
//        
// Con modificadores
// #include "MPCM.inc"
// #include "textures.inc"
// #declare MPCM_TexturaMadera          = T_Wood20
// object        { MPCM_Martillo( ) }
//

#include "MPCM_AU1.inc"
#include "colors.inc"
#include "woods.inc"
#include "textures.inc"
#declare MPCM_L                 = 0.001;

#if ( version < 3.2 )
  #ifndef( MPCM_POV3_1 )
    #declare MPCM_POV3_1        = on;
  #end
#else
  #ifndef( MPCM_POV3_1 )
    #declare MPCM_POV3_1        = off;
  #end
#end


#declare MPCM_DefaultTexturaMadera      =
  texture                       {
     T_Wood21
     rotate             90*x
  }          
  texture                       {
  pigment                       {    
    bumps       
    turbulence          1 
    scale               0.01
    pigment_map                 {  
      [ 0.0  Black ]
      [ 0.5  Brown transmit 0.8 ]
      [ 0.75 Clear ]
    }
  }                              
  }

#ifndef ( MPCM_TexturaMadera )
  #declare MPCM_TexturaMadera           = MPCM_DefaultTexturaMadera
#end  // #ifndef ( MPCM_TexturaMadera )
 
#declare MPCM_DefaultTexturaMaderaSuperior              =
  texture                       {
     T_Wood14
  }          
  texture                       {   
    pigment                     { 
      color Red transmit 0.7
    }
  }

#ifndef ( MPCM_TexturaMaderaSuperior )
  #declare MPCM_TexturaMaderaSuperior                   = MPCM_DefaultTexturaMaderaSuperior
#end  // #ifndef ( MPCM_TexturaMaderaSuperior )

 
#declare MPCM_DefaultTexturaMetal       =
  texture                       {
    pigment                     {
      agate   
      scale             0.01
      pigment_map               {  
        [ 0.0 Silver*0.8 ]
        [ 1.0 Silver*0.7 ]
      }
    }
    normal                      {
      agate
      scale             0.01
    }
    finish                      {
      metallic
    }
  }

#ifndef ( MPCM_TexturaMetal )
  #declare MPCM_TexturaMetal            = MPCM_DefaultTexturaMetal
#end  // #ifndef ( MPCM_TexturaMetal )

#macro MPCM_MartilloParaClavoMetal( AltoFundamental, AltoCabeza,
                GruesoFundamental, GruesoLateral, Lateral, LateralPosterior,
                TexturaMadera, TexturaMetal, TexturaMaderaSuperior )
  union                         {
    // CabezaMetal
    union                       {
      // SacaClavos
      difference                {
        // InterseccionSacaClavos
        intersection            {
          #local ArregloSacaClavos        = array [ 5 ]
              { < -3.93, -0.70,  0.25  >,
                < -1.79,  2.86,  1.0  >,
                <  1.31,  3.57,  0.5 >,
                <  1.31,  2.14,  0.5 >,
                < -1.79,  1.57,  1.0  > }
          #local ArregloSCProyXZ          = array [ 5 ]
              { < +GruesoLateral/2, 0, 0.5 >,
                < +0.46*GruesoLateral, -0.5*GruesoFundamental, 0.5 >,
                < -0.5*GruesoLateral-LateralPosterior, -0.64*GruesoFundamental, 0.25 >,
                < -0.5*GruesoLateral-LateralPosterior, +0.64*GruesoFundamental, 0.25 >,
                < +0.46*GruesoLateral, +0.5*GruesoFundamental, 0.5 > }
          #local ArregloSCProyYZ        = array [ 5 ]
              { < 0, +AltoCabeza, 0.5 >,
                <  0.5*GruesoFundamental, 0.95*AltoCabeza, 0.5 >,
                <  0.64*GruesoFundamental, -0.10*AltoCabeza, 0.25 >,
                < -0.64*GruesoFundamental, -0.10*AltoCabeza, 0.25 >,
                < -0.5*GruesoFundamental, 0.95*AltoCabeza, 0.5 > }
          // FrenteInterseccion SacaClavos
          object                  {
            MPCM_PrismaBezier( ArregloSacaClavos, false,
                  -GruesoFundamental, GruesoFundamental )
            scale                 ( 0.5*GruesoLateral+LateralPosterior )/3.93*<1,0,1>+y
            rotate                -90*x
          }  // FrenteInterseccion SacaClavos
          object                  {
            MPCM_PrismaBezier( ArregloSCProyXZ, false, -AltoCabeza/2, AltoCabeza )
          }  // FrenteInterseccion SacaClavos
          object                {
            MPCM_PrismaBezier( ArregloSCProyYZ, false, +0.5*GruesoLateral+LateralPosterior,
                        -0.5*GruesoLateral )
            rotate             -90*x
            rotate              90*y
          } 
          scale                 <1,AltoCabeza/0.0336,1>          
        }  // InterseccionSacaClavos
        // Hendidura diferencia de clavos
        box                     {
          -1, 1
          rotate                50*x
          scale                 <LateralPosterior*sqrt(2),LateralPosterior,GruesoFundamental/8>/sqrt( 2 )
          translate             -LateralPosterior*y
          translate             -0.5*LateralPosterior*x
          rotate                -45*z
        }  // Hendidura diferencia de clavos
        // Perfora Metal hendidura para madera
        cylinder                  {
          0.9*AltoCabeza*y, 1.1*AltoCabeza*y, 1
          scale           <Lateral*0.4,1,GruesoFundamental*0.2>
        }
      }  // SacaClavos
      // Cono de Golpe
      union                     {
        #local PuntoExtremo     = < Lateral/2+GruesoLateral,
                AltoCabeza-GruesoFundamental/2, 0 >;
        cone                    {
          PuntoExtremo, GruesoFundamental/2
          PuntoExtremo*<0,1,0>, GruesoFundamental/3
        }
        sphere                  {
          0, GruesoFundamental/2
          scale                 <1/5,1,1>
          translate             PuntoExtremo
        }
      } // Cono de Golpe
      // Base de Cabeza
      union                     {
        #local Factor1          = 0.1*GruesoLateral/AltoCabeza;
        #local Factor2          = 0.05*GruesoFundamental/AltoCabeza;
        superellipsoid          {
          < 0.2, 0.2 >
          scale                 < GruesoFundamental,
                        AltoCabeza*0.8, GruesoFundamental >/2
          translate             AltoCabeza*0.4*y
          matrix                < 1, 0, 0,
                                  Factor1, 1, Factor2,
                                  0, 0, 1,
                                  0, 0, 0 >
        }
        superellipsoid          {
          < 0.2, 0.2 >
          scale                 < GruesoFundamental,
                        AltoCabeza*0.8, GruesoFundamental >/2
          translate             AltoCabeza*0.4*y
          matrix                < 1, 0, 0,
                                  -1.5*Factor1, 1, Factor2,
                                  0, 0, 1,
                                  0, 0, 0 >
        }
        superellipsoid          {
          < 0.2, 0.2 >
          scale                 < GruesoFundamental,
                        AltoCabeza*0.8, GruesoFundamental >/2
          translate             AltoCabeza*0.4*y
          matrix                < 1, 0, 0,
                                  Factor1, 1, -Factor2,
                                  0, 0, 1,
                                  0, 0, 0 >
        }
        superellipsoid          {
          < 0.2, 0.2 >
          scale                 < GruesoFundamental,
                        AltoCabeza*0.8, GruesoFundamental >/2
          translate             AltoCabeza*0.4*y
          matrix                < 1, 0, 0,
                                  -1.5*Factor1, 1, -Factor2,
                                  0, 0, 1,
                                  0, 0, 0 >
        }
      }
      texture                   {
        TexturaMetal
      }
    }  // CabezaMetal
    // BaseMadera
    union                       {
      union                     {
        #local Eps              = 0.75;
        #local Factor1          = 0.15*GruesoLateral/AltoFundamental;
        #local Factor2          = 0.15*GruesoFundamental/AltoFundamental;
        superellipsoid            {
          <Eps,0.1>
          rotate                90*x
          scale           < 0.9*GruesoFundamental, 1.01*AltoFundamental, GruesoFundamental*0.9 >/2
          translate               -AltoFundamental/2*y
          matrix                < 1, 0, 0,
                                  +Factor1, 1, +Factor2,
                                  0, 0, 1,
                                  0, 0, 0 >
        }
        superellipsoid            {
          <Eps,0.1>
          rotate                90*x
          scale           < GruesoFundamental, 1.01*AltoFundamental, GruesoFundamental*0.9 >/2
          translate               -AltoFundamental/2*y
          matrix                < 1, 0, 0,
                                  -Factor1, 1, +Factor2,
                                  0, 0, 1,
                                  0, 0, 0 >
        }
        superellipsoid            {
          <Eps,0.1>
          rotate                90*x
          scale           < GruesoFundamental, 1.01*AltoFundamental, GruesoFundamental*0.9 >/2
          translate               -AltoFundamental/2*y
          matrix                < 1, 0, 0,
                                  +Factor1, 1, -Factor2,
                                  0, 0, 1,
                                  0, 0, 0 >
        }
        superellipsoid            {
          <Eps,0.1>
          rotate                90*x
          scale           < GruesoFundamental, 1.01*AltoFundamental, GruesoFundamental*0.9 >/2
          translate               -AltoFundamental/2*y
          matrix                < 1, 0, 0,
                                  -Factor1, 1, -Factor2,
                                  0, 0, 1,
                                  0, 0, 0 >
        }
      }
      // Perfora Metal
      cylinder                  {
        0.9*AltoCabeza*y, 1.0*AltoCabeza*y, 1
        scale           <GruesoLateral*0.35,1,GruesoFundamental*0.2>     
        texture                 {     
          TexturaMaderaSuperior
        }
      }
      texture                   {
        TexturaMadera
      }
    }  // BaseMadera
  }
#end  // #macro MPCM_MartilloParaClavoMetal

#macro MPCM_Martillo()
  object                        {
    #local L                    = MPCM_L;
    #local AltoFundamental      = 197.0*L;
    #local AltoCabeza           = 33.6*L;
    #local GruesoFundamental    = 19.3*L;
    #local GruesoLateral        = 28.6*L;
    #local Lateral              = 25.0*L;
    #local LateralPosterior     = 25.0*L;
    MPCM_MartilloParaClavoMetal( AltoFundamental, AltoCabeza,
        GruesoFundamental, GruesoLateral, Lateral, LateralPosterior,
        MPCM_TexturaMadera, MPCM_TexturaMetal, MPCM_TexturaMaderaSuperior )
  }
#end  // #macro MPCM_Martillo
