// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho...  19 mayo 2015
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY
//     
// MPCM MartilloParaClavoMetal
// El archivo dibuja un martillo corriente para reparaciones caseras.
// Es muy poco flexible, pero incluye una macro para modificar 
// algunas de sus caracteristicas principales.
// Es compatible con POVRay 3.1.
//
// La macro principal no tiene parametros  
// #macro MPCM_Martillo( )   
//
// La siguiente macro permite un mayor control de las caracteristicas.
// #macro MPCM_MartilloParaClavoMetal( AltoFundamental, AltoCabeza,
//                GruesoFundamental, GruesoLateral, Lateral, LateralPosterior,
//                TexturaMadera, TexturaMetal, TexturaMaderaSuperior )
//      AltoFundamental         : Referencia altura de la base de madera. 
//              Valor por defecto 197*L.      
//      AltoCabeza              : Altura de la cabeza del martillo.
//              Valor por defecto 33.6*L.
//      GruesoFundamental       : Referencia para el grueso del martillo.
//              Valor por defecto 19.3*L.
//      GruesoLateral           : Referencia para el grosor prependicular de la cabeza
//              del martillo en su zona central. Valor por defecto 28.6*L.
//      Lateral                 : Largo del cono de clavar. Valor por defecto 25.0*L.
//      LateralPosterior        : Largo de curva para arrancar clavos.
//              Valor por defecto 25.0*L.
//      TexturaMadera           : Textura de la madera soporte.
//              Valor por defecto MPCM_TexturaMadera.
//      TexturaMetal            : Textura de la cabeza del martillo.
//              Valor por defecto MPCM_TexturaMetal.
//      TexturaMaderaSuperior   : Textura del soporte superior para afirmar la cabeza
//              en la base. Valor por defect MPCM_TexturaMaderaSuperior.           
//
// El martillo se encuentra completamente contenido en las siguientes coordenadas.  
//      Minimo  = <- 40,-200, - 12 >*L
//      Maximo  = <  45,  34,   12 >*L   
// El martillo golpea hacia X+, cabeza hacia Y+ respecto de la base de madera.
// Se ha disenado para que la base de la cabeza metalica en contacto con la madera descanse
// en el plano XZ.                                     
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.  
// #declare MPCM_DefaultTexturaMadera  
//      Textura de la madera soporte.
// #declare MPCM_DefaultTexturaMetal       
//      Textura de la cabeza del martillo.
// #declare MPCM_DefaultTexturaMaderaSuperior         
//      Textura del soporte superior para afirmar la cabeza en la base.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)   
// #declare MPCM_TexturaMadera                  = texture { ... }                 
//      Textura de la madera soporte.
// #declare MPCM_TexturaMetal                   = texture { ... }
//      Textura de la cabeza del martillo.                                   
// #declare MPCM_TexturaMaderaSuperior          = texture { ... }
//      Textura del soporte superior para afirmar la cabeza en la base.
// #declare MPCM_POV3_1                                 = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//
// Para colocarlo simplemente
// #include "MPCM.inc"
// object        { MPCM_Martillo( ) }
//                           
// Ejemplo con la macro detallada, mismo objeto default
// #include "MPCM.inc"   
// object                       {
//   MPCM_MartilloParaClavoMetal( 0.197, 0.0336, 0.0193, 0.0286, 0.025, 0.025,
//              MPCM_TexturaMadera, MPCM_TexturaMetal, MPCM_TexturaMaderaSuperior )
// }
//        
// Con modificadores
// #include "MPCM.inc"
// #include "textures.inc"
// #declare MPCM_TexturaMadera          = T_Wood20
// object        { MPCM_Martillo( ) }
//

#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         

light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}    

#include "MPCM.inc"
   
#local FactorAcercamiento               = 5.5;   

object                          {
  MPCM_Martillo()   
  translate             0.08*y 
  translate       -( VecesCentroAbsoluto+1 )*( FactorAcercamiento-1 )
                        /( FactorAcercamiento )*OjoAbsoluto*L*z      
}
